/* split.c
	a program to split a file into a number of smaller files.
	conforms to UNIX specifications for split. */


#include <stdio.h

	char outputfilename[13];
	FILE *ip,
		 *op;
	int len;       /* used to manipulate file names */

main(argc, argv)
int argc;
char *argv[];
{
	int filesize = 1000;
	int x;
	int linecount = 0;
    FILE *fopen(), *fgets(), *fputs();
	UBYTE line[BUFSIZ];
	UBYTE *authorship = "written by Mark Hansel, 1/87";

	printf("split, %s\n",authorship);

	outputfilename[0] = NULL;
	if (argc == 2) /* 'split' + the input file name */
	{
		if (*argv[1] == '-') 
		{
			printf("usage: split -filesize <input file><outpout prefix>\n");
			exit(0);
		}

		 if ((ip = fopen(argv[1],"rb")) == NULL)
		 {
			  printf("ERROR: unable to open input file %s\n",argv[1]);
			  exit(0);
		 }
		 init_outf(outputfilename);
	}

	else if (argc == 3) /* choices: a) line count + input file.
									b) input file + output file. */
	{
		 if (*argv[1] == '-')	 /* option a. */
		 {
			  argv[1]++;
			  filesize = atoi(argv[1]);
			  if ((ip = fopen(argv[2],"rb")) == NULL)
			  {
				   printf("ERROR: unable to open input file %s\n",argv[2]);
				   exit(0);
			  }
	          init_outf(outputfilename);
         }
         else                /* option b*/
         {
              if((ip = fopen(argv[1])) == NULL)
              {
                   printf("ERROR: unable to open input file %s\n",argv[1]);
                   exit(0);
              }
              init_outf(argv[2]);
         }
    }

    else           /* 3 parameters -linecount <input file> <output file prefix>*/
    {
         if (*argv[1] != '-')
         {
              printf("USAGE: split -linecount <input file> <output file>\n");
              exit(0);
         }
         else	/* everything is ok */
         {
              argv[1]++;	/* the file size */
              filesize = atoi(argv[1]);
              if ((ip = fopen(argv[2],"rb")) == NULL)	/* input file name */
              {
                   printf("ERROR: unable to open input file %s\n",argv[2]);
                   exit(0);
              }
              init_outf(argv[3]);		/* output file name */
         }
    }

    if ((op = fopen(outputfilename,"wb")) == NULL)	/* open the output file */
    {
         printf("ERROR: unable to open output file %s\n",outputfilename);
         exit(0);
    }

    while (!feof(ip))		/* PROCESS FILE while there is input */
    {
         if (linecount < filesize && !feof(ip))
         {
              fgets(line, BUFSIZ, ip);
              fputs(line, op);
              linecount++;
         }
         else	/* output file full */
         {
			  fclose(op);	/* close it */
			  if (feof(ip)) break;	/* if end of input file, exit */
			  linecount = 0;		/* reinitialize */
			  incfilename(outputfilename);	/* reinitialize */
			  if ((op = fopen(outputfilename, "wb")) == NULL)	/* open next output file */
			  {
				   printf("unable to open an output file: %s\n",outputfilename);
				   exit(0);
			  }
		 }
	}
}

init_outf(name)
char *name;
{

    if ((len = strlen(name)) == 0)
    {
         strcpy (outputfilename, "xaa");
         len = 1;                       /* count 'x' only */
         return;
    }
    else if (len > 6)
    {
         printf("INIT_OUTF: output file name must be less than 6 characters\n");
         exit(0);
    }
    else
         strcpy(outputfilename,name);
         strcat(outputfilename, "aa");
         return;
}

incfilename(filename)
char *filename;
{
    int x = len+1;

    if (filename[x] < 'z') 
    {
         filename[x]++;
         return;
    }
    else
    {
         filename[x] = 'a';
         if (filename[x-1] < 'z') 
         	filename[x-1]++;
         else 
         {
              printf("too many files generated!\n");
              exit(0);
         }
    }
    return;
    
}
